]> git.sesse.net Git - backup.sh/blobdiff - backup.sh
skruebackup is no longer in use
[backup.sh] / backup.sh
index 6352fcebdff1b3a5eef94053292b9f58aea60ddc..cfac60723c6084aa1fdff420c4a86b1028225051 100755 (executable)
--- a/backup.sh
+++ b/backup.sh
 # The script is halfway Norwegian and halfway English. Newer modifications are
 # in English, we should probably stick to that.
 
-# The computer to backup.
-computer=$1
-
-# Configuration
-LOCKFILE=/home/backup/backuprun.lockfile.$computer
-confdir=/home/backup/conf/              # Configuration files
-storagedir=/backup                      # Where we keep backups
-maxnumfull=3                            # Number of full backups
-daysbetweenfull=30                      # Days between full backups
-daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
-                                        # full-backup date (in case the fixed day gets missed)
-DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
-DATE=`date "+%Y%m%d%H%M"`               #format: touch
-DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
-
-# Exclude-pattern
-exclude=$confdir/exclude
-[ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
+SCRIPTPATH="$( cd "$(dirname "$0")" ; pwd -P )"  # Absolute directory the script lives in
+confdir=$SCRIPTPATH/conf/                        # Directory configuration files
+[ -r $confdir/env ] && . $confdir/env
+
+# Default configuration; used unless $confdir/env has set something different.
+storagedir=${storagedir:-/backup}                # Where we keep backups
+exclude=${exclude:-$confdir/exclude}             # List of exclude patterns
+maxnumfull=${maxnumfull:-3}                      # Number of full backups
+daysbetweenfull=${daysbetweenfull:-30}           # Days between full backups
+
+# Days between full backups for machines with fixed full-backup date
+# (in case the fixed day gets missed).
+daysbetweenfullforfixed=${daysbetweenfullforfixed:-32}
+
+# End of configuration.
+
+computer=$1                                      # The computer to backup.
+LOCKFILE=$SCRIPTPATH/backuprun.lockfile.$computer
+DAY_OF_MONTH=`date "+%d" | sed s/^0//`           # from 1 to 31
+DATE=`date "+%Y%m%d%H%M"`                        # format: touch
+DATEs=`date "+%Y-%m-%d %H:%M"`                   # format: tar
 
 if [ -z "$computer" ]; then
        echo "Usage: $0 COMPUTER"
        exit 1
 fi
 
+[ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
+
 # Die more or less gracefully (at least notify user)
 die() {
        warnmsg "Aborting."
@@ -63,9 +68,10 @@ infomsg() {
 # Trap C-c and kill
 trap die SIGINT SIGTERM
 
-# Don't start if we're already running
+# Don't start if we're already running. Don't use diemsg, as that removes the lock file!
 if [ -e $LOCKFILE ]; then
-       diemsg "$LOCKFILE exists for pid `cat $LOCKFILE`."
+       warnmsg "$LOCKFILE exists for pid `cat $LOCKFILE`."
+       exit 1
 fi;
 touch $LOCKFILE
 echo $$ > $LOCKFILE
@@ -79,12 +85,12 @@ backup()
        infomsg "$computer:$filesystem $backuplevel backup"
 
        localsnar="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
-       remotesnar="/root/.backup/${sfilesystem}.snar"
+       remotesnar="$remotehome/.backup/${sfilesystem}.snar"
        if [ "$backuplevel" = "daglig" ]; then
                # If incremental backup, we need to copy the incremental status to $computer.
                # If it does not exist, whine a bit and then run date-based instead.
                if [ -s "$localsnar" ]; then
-                       if ! scp $localsnar root@$computer:$remotesnar; then
+                       if ! scp $localsnar $username@$computer:$remotesnar >&2; then
                                diemsg "Could not copy .incremental.snar to $computer"
                        fi
                        lastcmd="--listed-incremental=$remotesnar --no-check-device"
@@ -101,6 +107,16 @@ backup()
                lastcmd="--listed-incremental=$remotesnar"
        fi
 
+       # The file is usually stored to disk with a simple cat > $TARFILE,
+       # but in some cases, like backing up to a remote and untrusted
+       # file system, it could be useful to replace it with e.g.
+       # a GPG command line.
+       if [ -f $confdir/storageprogram.$computer ]; then
+               storageprogram=`cat $confdir/storageprogram.$computer`
+       else
+               storageprogram=cat
+       fi
+
        # We try to run tar on the remote computer
        #    c create archive
        #    C change to directory first
@@ -112,8 +128,8 @@ backup()
        #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
        #    file and build a file list, respectivly.  
        TARFILE=$DATE.tmp
-       TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
-               --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
+       TARCMD="ssh -n $username@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
+               --exclude-from=$remotehome/.backup/exclude\" | pee \"$storageprogram > $TARFILE\" \"tar tzvf -\""
        infomsg "Running $TARCMD"
        eval $TARCMD > $DATE.idx
 
@@ -121,7 +137,7 @@ backup()
                # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
  
                if [ "$remotesnar" ]; then
-                       if ! scp root@$computer:$remotesnar $localsnar.tmp; then
+                       if ! scp $username@$computer:$remotesnar $localsnar.tmp >&2; then
                                diemsg "Could not copy .incremental.snar from $computer"
                        fi
                fi
@@ -135,15 +151,55 @@ backup()
                # Update timestamp
                echo $DATEs > ../.date && touch -t $DATE ../.date
 
-               # Make a sorted file list as well
-               sort -k6 < $DATE.idx > $DATE.sdx
-
                # Fix permissions
                chmod 600 *tgz                      #only for us
-               chmod 644 *sdx *idx 2>/dev/null     #everyone can read
+               chmod 644 *idx 2>/dev/null          #everyone can read
 
                # Let the remote computer know that we ran a successful backup (for nagios)
-               ssh root@$computer touch $filesystem/.lastbackup
+               ssh -n $username@$computer touch $filesystem/.lastbackup
+       else
+               # Something wrong happened.
+               rm $TARFILE
+               diemsg "tar failed or $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
+       fi
+}
+
+# Non-privileged backups currently have a few limitations compared to regular ones:
+#
+#  - No .idx files.
+#  - No .snar-style incremental backups, only date-based.
+#  - No touching of .lastbackup for Nagios.
+#  - Failed tar operations may go undetected, since we only see the error code
+#    the last process in the pipe chain, which is gpg.
+#  - No storageprogram support (see above), because the file is typically already
+#    encrypted.
+nonprivbackup()
+{
+       infomsg "$computer:$filesystem $backuplevel non-privileged backup"
+
+       if [ "$backuplevel" = "daglig" ]; then
+               lastd=`cat ../.date`
+               lastcmd="'$lastd'"
+       else
+               lastcmd=""
+       fi
+
+       TARFILE=$DATE.tmp
+       TARCMD="ssh -n $username@$computer \"sudo /usr/local/sbin/output-encrypted-backup $filesystem $lastcmd\""
+       infomsg "Running $TARCMD"
+       eval $TARCMD > $TARFILE
+
+       if [ $? -eq 0 ] && [ -s $TARFILE ]; then
+               # File is >0 in size and the remote side did not report any fatal errors; we assume it worked.
+
+               # Move tar file in place
+               mv $TARFILE $DATE.tgz.gpg
+
+               # Update timestamp
+               echo $DATEs > ../.date && touch -t $DATE ../.date
+
+               # Fix permissions
+               chmod 600 *tgz.gpg                  #only for us
        else
                # Something wrong happened.
                rm $TARFILE
@@ -161,16 +217,29 @@ targetfilesystem=`df -P "$storagedir/$computer"`
 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
        diemsg "Target filesystem ($storagedir/$computer) was mounted on /."
 fi
+# Find the user to do the backup as.
+if [ -f $confdir/username.$computer ] ; then
+       username=`cat $confdir/username.$computer`
+else 
+       username=root
+fi
 
 infomsg "Backing up $computer"
 
 # Try to SSH to the computer without entering a password.
-if ! ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true; then
+if ! ssh -n -o NumberOfPasswordPrompts=0 $username@$computer /bin/true; then
        diemsg "Could not use passwordless SSH."
 fi
 
+# Find the home directory of the backup user
+remotehome=`ssh -n $username@$computer "echo ~"`
+if [ -z "$remotehome" ]; then
+       diemsg "Could not expand ~ for user $username"
+fi
+
 # Check if pigz is available
-if ssh -n root@$computer "pigz -V 2>/dev/null"; then
+if ssh -n $username@$computer "pigz -V 2>/dev/null"; then
        compressor=pigz
 else
        infomsg "pigz missing; falling back to gzip."
@@ -178,37 +247,37 @@ else
 fi
 
 # Check dump bit in fstab
-filesystems=`ssh -n root@$computer "cat /etc/fstab" \
+filesystems=`ssh -n $username@$computer "cat /etc/fstab" \
        | grep -v nfs \
        | grep -v "^#" \
        | grep -v "^$" \
        | awk '{ if ( $(NF-1) != "0" ) print $2}' `
 
 # Clean up our dir at this client
-if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
-       diemsg "Could not create backup staging area at $computer:/root/.backup"
+if ! ssh -n $username@$computer "rm -r $remotehome/.backup ; mkdir -m 700 $remotehome/.backup"; then
+       diemsg "Could not create backup staging area at $computer:$remotehome/.backup"
 fi
 
 # Try to copy $exclude to $computer
-if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
+if ! scp $exclude $username@$computer:$remotehome/.backup/exclude >&2; then
        diemsg "Could not copy exclude.txt to $computer"
 fi
 
 # Try to copy preeexec and postexec if they exist
 if [ -f $confdir/preexec.$computer ]; then
-       if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
-               diemsg "Could not copy preexec.$computer to $computer:/root/.backup/preexec"
+       if ! scp $confdir/preexec.$computer $username@$computer:$remotehome/.backup/preexec >&2; then
+               diemsg "Could not copy preexec.$computer to $computer:$remotehome/.backup/preexec"
        fi
 fi
 if [ -f $confdir/postexec.$computer ]; then
-       if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
-               diemsg "Could not copy postexec.$computer to $computer:/root/.backup/postexec"
+       if ! scp $confdir/postexec.$computer $username@$computer:$remotehome/.backup/postexec >&2; then
+               diemsg "Could not copy postexec.$computer to $computer:$remotehome/.backup/postexec"
        fi
 fi
 
 # Try to run preexec if it exists
-if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
-       diemsg "Could not run $computer:/root/.backup/preexec"
+if ! ssh -n $username@$computer "[ ! -f $remotehome/.backup/preexec ] || /bin/bash -x $remotehome/.backup/preexec" >&2; then
+       diemsg "Could not run $computer:$remotehome/.backup/preexec"
 fi
 
 for filesystem in $filesystems; do
@@ -242,7 +311,7 @@ for filesystem in $filesystems; do
                fullbackup_min_for_this_machine=$daysbetweenfull 
        fi
 
-       if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
+       if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz\* -mtime -$fullbackup_min_for_this_machine`" ]; then
                backuplevel=full
        fi
 
@@ -250,7 +319,11 @@ for filesystem in $filesystems; do
        cd $storagedir/$computer/$sfilesystem/$backuplevel || diemsg "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
 
        # Perform the actual backup
-       backup
+       if [ "$username" = "root" ]; then
+               backup
+       else
+               nonprivbackup
+       fi
 
        # Check if this box has a custom number of full backups
        if [ -f $confdir/maksfulle.$computer.$sfilesystem ]; then
@@ -262,14 +335,14 @@ for filesystem in $filesystems; do
        fi
 
        # Delete old full backups
-       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`; do
+       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz* | tail -n +$mf`; do
                prefix=`echo $full | sed "s/\.[^.]*$//"`
                infomsg "$computer:$filesystem Deleting full backup $prefix"
                rm $prefix*
        done
 
        # Delete incremental backups older than the oldest full backup
-       oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
+       oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz* | tail -1`
        find \
                $storagedir/$computer/$sfilesystem/daglig \
                -type f \
@@ -279,12 +352,12 @@ for filesystem in $filesystems; do
 done
 
 # Try to run postexec if it exist
-if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
-       diemsg "Could not run $computer:/root/.backup/postexec"
+if ! ssh -n $username@$computer "[ ! -f $remotehome/.backup/postexec ] || /bin/bash -x $remotehome/.backup/postexec" >&2; then
+       diemsg "Could not run $computer:$remotehome/.backup/postexec"
 fi
 
 # Use warn so that we will get an email even on success.
-warnmsg "$computer: Backup completed successfully."
+warnmsg "Backup completed successfully."
 
 # Remove lockfile
 rm $LOCKFILE